'PMP Paint Demo


CON

  _clkmode = xtal1 + pll16x
  _xinfreq =5_000_000               


OBJ

  lcd : "QMP_DisplayDriver2d_ILI9340"  'Controls the LCD
  i2c: "QMP_I2CDriver" 

VAR
  long touchx, touchy, bStillDown 

PUB start | i, dx,dy,GraphicsColor
    'initialize the LCD
  lcd.start
  
  InitScreen

  Paint

Pub InitScreen
  lcd.FillScreen(lcd#rgb_midnightblue)
  lcd.SetFont(@font1)
  lcd.SetFontColors(lcd#rgb_yellow,lcd#rgb_midnightblue) 
  lcd.DrawString(50,0,string("QMP Paint!")) 

Pub Paint |xc,yc,n,color 
  color:=lcd#rgb_white  


  repeat
    WaitStylusDown
    if touchy<0  'this is one of the virtual buttons
      n:=touchx*5/240
      case n
        4:
          color:=lcd#rgb_white 
        3:
          color:=lcd#rgb_red 
        2:
          color:=lcd#rgb_green 
        0:
          InitScreen
    lcd.setpixel(color,touchy,239-touchx)

 

PUB bTouchDown|tx,ty,z1,z2,tz  
  tx:=i2c.GetTouchX
  z1:=i2c.GetTouchZ1
  z2:=i2c.GetTouchZ2
  tz:=tx*(z2-z1)/z1
  if (tz<100000) and (tz>10000)           'You might have to tweak these values for some displays...
    return true
  else
    return false

PUB WaitStylusUp
  'Wait for stylus to be up
  repeat
    waitcnt(cnt+clkfreq/100)  
    if !bTouchDown
    return

    
PUB WaitStylusDown|tx,ty,z1,z2,tz
  'Wait for stylus to be down then update touchx, touchy and return
  repeat
    if bTouchDown
      tx:=i2c.GetTouchX
      ty:=i2c.GetTouchY
      z1:=i2c.GetTouchZ1
      z2:=i2c.GetTouchZ2
      'take another x,y reading and average
      tx+=i2c.GetTouchX
      ty+=i2c.GetTouchY
      tx>>=1
      ty>>=1
      tz:=tx*(z2-z1)/z1
      if (tz<200000) and (tz>10000)
        touchx:=(tx-touchx0)/touchdx
        touchy:=(ty-touchy0)/touchdy
        return
      else
        bStillDown:=false
    else
      bStillDown:=false    


DAT 'Default Touchscreen Calibrations
'based on these reading:
'  Top of landscape screen: x=60600, Bottom of landscape screen: x=4560   
'  Left of landscape screen (screen only, not buttons): y=6200,  Right of landscape screen:  y=60600
'  Left of button area:  (y=1500)  
touchx0 long 4560
touchdx long (60600-4560)/240
touchy0 long 6200
touchdy long (60600-6200)/320




DAT  'Font:  Custom font located here.  Other fonts can be selected with the SetFont command
'Note:  If you do not need a font, you can save space by commenting out the file command line below
        
font1 long
file "ProgoCo_wHeader.dat"   'nice 8x16 fixed pitch font